package com.ruoyi.ems.service;

import java.util.List;

import com.ruoyi.ems.domain.EmsDevice;
import com.ruoyi.ems.domain.vo.QueryDevice;
import com.ruoyi.ems.domain.vo.TreeEntity;

/**
 * 能源设备Service接口
 *
 * @author ruoyi
 * @date 2024-07-10
 */
public interface IEmsDeviceService {
    /**
     * 查询能源设备
     *
     * @param id 能源设备主键
     * @return 能源设备
     */
    EmsDevice selectEmsDeviceById(Long id);

    /**
     * 查询能源设备
     * @param code 设备编码
     * @return 能源设备
     */
    EmsDevice selectByCode(String code);

    /**
     * 查询能源设备列表
     *
     * @param queryDevice 能源设备
     * @return 能源设备集合
     */
    List<EmsDevice> selectEmsDeviceList(EmsDevice queryDevice);

    /**
     * 查询能源设备列表
     *
     * @param emsDevice 能源设备
     * @return 能源设备集合
     */
    List<EmsDevice> selectByAreaTree(QueryDevice emsDevice);

    /**
     * 根据设施获取设备树结构
     * @param areaCode 区域编码
     * @return 设备树结构
     */
    List<TreeEntity> getTreeByFacs(String areaCode);

    /**
     * 新增能源设备
     *
     * @param emsDevice 能源设备
     * @return 结果
     */
    int insertEmsDevice(EmsDevice emsDevice);

    /**
     * 修改能源设备
     *
     * @param emsDevice 能源设备
     * @return 结果
     */
    int updateEmsDevice(EmsDevice emsDevice);

    /**
     * 批量删除能源设备
     *
     * @param ids 需要删除的能源设备主键集合
     * @return 结果
     */
    int deleteEmsDeviceByIds(Long[] ids);

    /**
     * 删除能源设备信息
     *
     * @param id 能源设备主键
     * @return 结果
     */
    int deleteEmsDeviceById(Long id);
}
